unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Spin, Math;

type
  { TExtendedPoint }
  TExtendedPoint = record
    X, Y: Extended;
  end;

  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { private declarations }
    shape: Integer;
    procedure sierpinskiDreieck(iterationstiefe: Integer; A, B, C: TExtendedPoint; myCanvas: TCanvas);
    procedure kochLinie(iterationstiefe: Integer; A, B: TExtendedPoint; myCanvas: TCanvas);
 //   procedure peanoKurve(iterationstiefe);
    procedure drachenKurve(iterationstiefe: Integer; A, B: TExtendedPoint; myCanvas: TCanvas);
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
var
  pA, pB, pC: TExtendedPoint;
  iterationen: Integer;
begin
  Image1.Width:=Form1.Width-1;
  Image1.Height:=Form1.Height-65;
  Image1.Picture.Clear;
  Image1.Canvas.Clear;
  Image1.Canvas.Brush.Color:=$222222;
  Image1.Canvas.FillRect(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.Pen.Color:=$008cff;
  iterationen:=SpinEdit1.Value;
  case shape of
    0:
    begin
      pA.X:=Image1.Width / 2;
      pA.Y:=10;
      pB.X:=Image1.Width-10;
      pB.Y:=Image1.Height-10;
      pC.X:=10;
      pC.Y:=Image1.Height-10;
      sierpinskiDreieck(iterationen, pA, pB, pC, Image1.Canvas);
    end;
    1:
    begin
      pA.X:=10;
      pA.Y:=Image1.Height/3;
      pB.X:=Image1.Width-10;
      pB.Y:=Image1.Height/3;
      kochLinie(iterationen, pA, pB, Image1.Canvas);
    end;
   // 2: peanoKurve(iterationen);
    3:
    begin
      pA.X:=Image1.Width/4;
      pA.Y:=Image1.Height/3;
      pB.X:=Image1.Width-pA.X;
      pB.Y:=Image1.Height/3;
      drachenKurve(iterationen, pA, pB, Image1.Canvas);
    end;
    4:
    begin

    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if shape>0 then dec(shape)
  else shape:=3;
  case shape of
  0: Label1.Caption:='Sierpinski triangle';
  1: Label1.Caption:='Koch curve';
  2: Label1.Caption:='Peano curve';
  3: Label1.Caption:='Dragon curve';
  4: Label1.Caption:='Mandelbrot';
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if shape<4 then inc(shape)
  else shape:=0;
  case shape of
  0: Label1.Caption:='Sierpinski triangle';
  1: Label1.Caption:='Koch curve';
  2: Label1.Caption:='Peano curve';
  3: Label1.Caption:='Dragon curve';
  4: Label1.Caption:='Mandelbrot';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Left:=0;
  Image1.Width:=Form1.Width-1;
  Image1.Top:=64;
  Image1.Height:=Form1.Height-65;

  shape:=0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Image1.Width:=Form1.Width-1;
  Image1.Height:=Form1.Height-65;
end;

procedure TForm1.sierpinskiDreieck(iterationstiefe: Integer; A, B, C: TExtendedPoint; myCanvas: TCanvas);
var
  Anew,Bnew,Cnew: TExtendedPoint;
begin
  Image1.Canvas.MoveTo(Round(A.X), Round(A.Y));
  Image1.Canvas.LineTo(Round(B.X), Round(B.Y));
  Image1.Canvas.LineTo(Round(C.X), Round(C.Y));
  Image1.Canvas.LineTo(Round(A.X), Round(A.Y));

  Anew.X:=(C.X+B.X) / 2;
  Anew.Y:=(C.Y+B.Y) / 2;
  Bnew.X:=(A.X+C.X) / 2;
  Bnew.Y:=(A.Y+C.Y) / 2;
  Cnew.X:=(B.X+A.X) / 2;
  Cnew.Y:=(B.Y+A.Y) / 2;

  if iterationstiefe > 0 then
  begin
    sierpinskiDreieck(iterationstiefe-1, A, Cnew, Bnew, myCanvas);
    sierpinskiDreieck(iterationstiefe-1, Cnew, B, Anew, myCanvas);
    sierpinskiDreieck(iterationstiefe-1, Bnew, Anew, C, myCanvas);
  end;
end;

procedure TForm1.kochLinie(iterationstiefe: Integer; A, B: TExtendedPoint; myCanvas: TCanvas);
var
  C, D, E: TExtendedPoint;
  alpha, laenge: Extended;
begin
  if iterationstiefe > 0 then
  begin

    alpha:=arctan2((B.Y-A.Y), (B.X-A.X))+pi/3;
    C.X:=A.X+((B.X-A.X)/3);
    C.Y:=A.Y+((B.Y-A.Y)/3);
    E.X:=A.X+(2*(B.X-A.X)/3);
    E.Y:=A.Y+(2*(B.Y-A.Y)/3);
    laenge:=sqrt((C.X-A.X)*(C.X-A.X) + (C.Y-A.Y)*(C.Y-A.Y));
    D.X:=C.X+cos(alpha)*laenge;
    D.Y:=C.Y+sin(alpha)*laenge;

    kochLinie(iterationstiefe-1, A, C, myCanvas);
    kochLinie(iterationstiefe-1, C, D, myCanvas);
    kochLinie(iterationstiefe-1, D, E, myCanvas);
    kochLinie(iterationstiefe-1, E, B, myCanvas);

  end
  else
  begin
    myCanvas.Line(Round(A.X), myCanvas.Height-Round(A.Y), Round(B.X), myCanvas.Height-Round(B.Y));
  end;
end;

procedure TForm1.drachenKurve(iterationstiefe: Integer; A, B: TExtendedPoint; myCanvas: TCanvas);
var
  C: TExtendedPoint;
begin
  C.X:=(A.X+B.X+A.Y-B.Y)/2;
  C.Y:=(-A.X+B.X+A.Y+B.Y)/2;

  if iterationstiefe > 0 then
  begin
    drachenKurve(iterationstiefe-1, A, C, myCanvas);
    drachenKurve(iterationstiefe-1, B, C, myCanvas);
  end
  else
  begin
    myCanvas.Line(Round(A.X), Round(A.Y), Round(C.X), Round(C.Y));
    myCanvas.Line(Round(C.X), Round(C.Y), Round(B.X), Round(B.Y));
  end;

end;

initialization
  {$I unit1.lrs}

end.

